Subject: bug#50951: 28.0.50; Urdu text is not displayed correctly

From: Eli Zaretskii <[email-masked]>
Date: Mon, 05 Sep 2022 15:29:35 +0300

> From: Rah Guzar <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>, [email-masked]
> Date: Mon, 05 Sep 2022 13:57:24 +0200
> 
> 
> Lars Ingebrigtsen <[email-masked]> writes:
> 
> > I've only lightly skimmed this thread, but it seems like at least some
> > of the problems were solved.  Is there anything more to do here on the
> > Emacs side?
> 
> Hi Lars and Eli,
>    I am on emacs 28 so this might not be accurate for the development
>    version of emacs. Right now urdu text renders fine for me using the
>    default font which for me is,
> 
>    -AXIS-Zohra Unicode-normal-normal-normal-*-32-*-*-*-*-0-iso10646-1
> 
>    So that aspect has improved.
> 
>    However if I change my font to Noto Nastaliq by evaluating,
> 
>    (set-fontset-font t 'arabic (font-spec :family "NotoNastaliqUrdu"))
> 
>    rendering is still bad. There are nastaliq fonts
>    (very big ones) that render fine. My experience is that if font size
>    is around 10 megabytes it renders fine, if the size is less than that
>    it has problems (on my system Noto Nastaliq is 1.1M).
> 
>    As in the thread this is specific to emacs and not a problem with
>    harfbuzz generally.

It is unclear to me why this conclusion.  Emacs uses HarfBuzz, and the
only factor that could affect that, apart from selecting the font, is
the setting of the current-iso639-language variable, which AFAIR
Rahguzar tried setting with no success.

>    So situation is acceptable but needs workarounds to get a good
>    experience.

My conclusion from this is that Noto Nastaliq is not a good font for
Urdu.